<?php
/**
 * CodeIgniter Portlet
 *
 * PHP version 5
 *
 * @package portlet
 * @version $Id: $
*/

require_once APPPATH.'us_libraries/Portlet'.EXT;
require_once APPPATH.'us_libraries/Widget_interface'.EXT;
require_once APPPATH.'us_libraries/Widget_editable_interface'.EXT;

/**
 * A node.js chat portlet
 */
class Com_untermstrich_nodejs_chat extends Portlet implements Widget_interface, Widget_editable_interface
{
    /**
     * @param   array   $params     Optional The parameters
     * @return  string  The page
     *
     * @uses US_Smarty
     */
    public static function view(array $params=array())
    {
        //Load the language file
        self::$CI->lang->load('reporting', self::$CI->web_settings->getLanguage());
        self::$CI->smarty->assign_lang_info();  
        
        //Add the scripts
        self::set_script_file('pub_js.js?v='.self::$CI->config->item('us_version'), 'com_untermstrich_nodejs_chat', 'com_untermstrich_nodejs_chat/views');
        
        self::$CI->smarty->assign('unique_id', $params['unique_id']);
        self::$CI->smarty->assign('xjxcookie', self::$CI->login->get_xsrf());
        
        self::add_run_script("com_untermstrich_nodejs_chat.init('".$params['unique_id']."');");
        
        return self::$CI->smarty->view('view', true, self::$portlet_dir.'views/').self::write();        
    }
    
    /**
     * Processes xajax calls used by the portlet
     *
     * @param   Page    $the_page   The page the portlet is added to
     * @return  void
     */
    public static function process(Page $the_page)
    {
        $action = strtolower(self::$CI->input->post('val1'));
        switch ($action) {
            case 'load_messages':
                self::_load_messages($the_page);
                break;
            default:
                break;
        }
        self::write();        
    }
    
     /**
     * Load messages
     *
     * @param   object  $the_page       The current page controller
     * @return void
     */
    private static function _load_messages(Page $the_page)
    {
        //Load libraries
        $the_page->init_smarty(My_controller::M_XAJAX);
        self::$CI->load->model('Node_chat_message_model', 'node_chat_message');

        $portlet_id = self::$CI->input->post('val2');
        $uid = self::$CI->input->post('val3');
        $room = self::$CI->input->post('val4');
        
        //Get last 100 messages
        $request_vars = new stdClass();
        $request_vars->room = $room;
        $messages = self::$CI->node_chat_message->get_list($request_vars, 0, 100, Node_chat_message_model::DB_ALIAS.'.created_date', 2);
        $messages = array_reverse($messages);
        foreach ($messages as $message) {
            $message->created_date = $message->created_date->mysql();
        }
        
        self::add_run_script('com_untermstrich_nodejs_chat.render_messages("'.$portlet_id.'", "'.$uid.'", '.us_json_encode($messages).', "'.$room.'");');
    }
    
    /**
     * Get information about the widget
     *
     * @return  object
     */
    public  static function get_widget_information()
    {
        $reply = new stdClass();
        $reply->main_title = 'basic_basis';
        $reply->title = 'com_untermstrich_nodejs_chat_title';
        $reply->link = null;
        $reply->help_link = ':basics:basics:butler:chat';
        $reply->removable = true;
        $reply->complex_right = true;
        $reply->print = false;
        $reply->updateable = false;
        return $reply;
    }    
    
   /**
     * Get a config page for the widget XAJAX
     *
     * @param   array   $params   Diffent params
     * @return  string
     */    
    public static function get_widget_configpage(array $params=array())
    {
        return '';
        return self::$CI->smarty->view('config', true, self::$portlet_dir.'views/').self::write();  
    }   
    
    /**
     * Save a config page for the widget XAJAX
     *
     * @param   array   $params   Different params
     * @return  string
     */
    public static function save_configpage(array $params = array())
    {
        
    }    
} // END class Com_untermstrich_nodejs_chat